#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <GL/glut.h>
#define MAXPTS 200
#define EPS 0.000001

typedef struct { double c[205]; int deg; } tPoly;

int mousex, mousey;
int sirka=640, vyska=480;
int pts=0;
double P[205][3];
int sel_pt=-1;
tPoly Poly;

void bitmap_output(int x, int y, char *string, void *font) {
  int len, i;
  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) glutBitmapCharacter(font, string[i]);
}

void ComputePoly(void){
  tPoly P1,P2;
  int robim,uz,nasob,i;
  double pow,val;
  
  if (pts==0) return;
  if (pts==1) { Poly.deg=0; Poly.c[0]=P[0][1]; return; }
  uz=0; Poly.deg=0; Poly.c[0]=0;
  for (robim=0;robim<pts;robim++) {
    P1.deg=0; P1.c[0]=1;
    for (nasob=0;nasob<pts;nasob++) if (robim!=nasob) {
      for (i=0;i<=P1.deg;i++) P2.c[i+1]=P1.c[i]; P2.c[0]=0;
      for (i=0;i<=P1.deg;i++) P2.c[i]+=P1.c[i]*(-P[nasob][0]);
      P1.deg++; for (i=0;i<=P1.deg;i++) P1.c[i]=P2.c[i];
    }
    pow=1.0; val=0.0;
    for (i=0;i<=P1.deg;i++) { val+=pow*P1.c[i]; pow*=P[robim][0]; }
    for (i=0;i<=P1.deg;i++) P1.c[i]=(P1.c[i]/val)*P[robim][1];
    
    if (!uz) {
      Poly.deg=P1.deg; for (i=0;i<=P1.deg;i++) Poly.c[i]=P1.c[i]; uz=1;
    } else {
      for (i=Poly.deg+1;i<=P1.deg;i++) Poly.c[i]=0.0;
      for (i=0;i<=P1.deg;i++) Poly.c[i]+=P1.c[i];
      if (P1.deg>Poly.deg) Poly.deg=P1.deg;
    }
  }
}

double EvalPoly(double kde){
  double pow,val;
  int i;
  
  pow=1.0; val=0.0;
  for (i=0;i<=Poly.deg;i++) { val+=pow*Poly.c[i]; pow*=kde; }
  return val;
}

void display(void) {
  char msg[1000];
  double p1[3],p2[3];
  int i,j;
  
  glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(1, 0, 0);

//  if (pts>0) for (i=Poly.deg;i>=0;i--) {
//    sprintf(msg,"%.3f x^%d",Poly.c[i],i);
//    bitmap_output(20, 20*(i+1), msg,GLUT_BITMAP_TIMES_ROMAN_24);
//  }
//  sprintf(msg,"[%d %d] pts=%d",mousex,mousey,pts);
//  bitmap_output(40, 35, msg,GLUT_BITMAP_TIMES_ROMAN_24);
  ComputePoly();
  if (pts>0) for (i=0;i<sirka;i++) {
    glBegin(GL_LINE_STRIP);
      p1[0]=i; p1[1]=EvalPoly((double)i); p1[2]=0; p2[0]=i+1; p2[1]=EvalPoly((double)(i+1)); p2[2]=0;
      glVertex3dv(p1);
      glVertex3dv(p2);
    glEnd();
  }
  glPointSize(10);
  glColor3f(0.6, 0, 0);
  for (i=0;i<pts;i++) { 
    glBegin(GL_POINTS);
      glVertex3dv(P[i]);
    glEnd();
  }

  glFlush();
}

void reshape(int w, int h) {
  sirka=w; vyska=h;
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);
}

void keyPressed(unsigned char key, int x, int y) { 
  if (key == 27) exit(0); 
}

void motion(int x, int y) {
//  float selx, sely;

//  computeCoords(sel_piece, x, y, &selx, &sely);
//  moveSelection(selx, sely);
  if (sel_pt!=-1) {
    P[sel_pt][0]=x; P[sel_pt][1]=y;
  }
  mousex = x;
  mousey = y;
  glutPostRedisplay();
}

void mouse(int b, int s, int x, int y) {
  int i,ok;

  mousex = x;
  mousey = y;
  if (b==GLUT_LEFT_BUTTON){
    // pridavame / rusime
    if (s==GLUT_DOWN) {
      
      ok=1;
      for (i=0;i<pts;i++) if (abs(P[i][0]-x)<=4) {
        ok=0;
        if (abs(P[i][1]-y)<=4) {
          // mazeme
          P[i][0]=P[pts-1][0]; P[i][1]=P[pts-1][1]; P[i][2]=P[pts-1][2]; pts--;
        }
        break;
      }
      if ((ok) && (pts<MAXPTS)) {
        P[pts][0]=x; P[pts][1]=y; P[pts][2]=0; pts++;
      }
      
    }
  } else {
    // hybeme
    if (s==GLUT_DOWN) {
      // vybrali sme si (?)
      sel_pt=-1;
      for (i=0;i<pts;i++) if ((abs(P[i][0]-x)<=4) && (abs(P[i][1]-y)<=4)) { sel_pt=i; break; }
    } else {
      // pustili sme
      sel_pt=-1;
    }
  }
  
  if ((s==GLUT_DOWN) && (b==GLUT_LEFT_BUTTON)) {
    // prejdi ci nemazemem, resp. nic nerobime
  }
  glutPostRedisplay();
  motion(x,y);
}

int main(int argc, char **argv) {
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
  glutInitWindowSize(640, 480);
  glutInitWindowPosition(0, 0);
  glutCreateWindow("Miso Forisek -- DU #1");
  glClearColor(0.0, 0.0, 0.0, 0.0);
  glColor3f(1, 0, 0);
  glLineWidth(1.0);
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keyPressed);
  glutMotionFunc(motion);
  glutMouseFunc(mouse);
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
